poj 1463 Strategic game

2024-03-24 07:32
文章标签 poj game strategic 1463

本文主要是介绍poj 1463 Strategic game,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

原题:
Strategic game
Time Limit: 2000MS Memory Limit: 10000K
Total Submissions: 13192 Accepted: 5971

Description
Bob enjoys playing computer games, especially strategic games, but sometimes he cannot find the solution fast enough and then he is very sad. Now he has the following problem. He must defend a medieval city, the roads of which form a tree. He has to put the minimum number of soldiers on the nodes so that they can observe all the edges. Can you help him?

Your program should find the minimum number of soldiers that Bob has to put for a given tree.
Input
The input contains several data sets in text format. Each data set represents a tree with the following description:

the number of nodes
the description of each node in the following format
node_identifier:(number_of_roads) node_identifier1 node_identifier2 ... node_identifiernumber_of_roads
or
node_identifier:(0)

The node identifiers are integer numbers between 0 and n-1, for n nodes (0 < n <= 1500);the number_of_roads in each line of input will no more than 10. Every edge appears only once in the input data.

Output
The output should be printed on the standard output. For each given input data set, print one integer number in a single line that gives the result (the minimum number of soldiers). An example is given in the following:

Sample Input

4
0:(1) 1
1:(2) 2 3
2:(0)
3:(0)
5
3:(3) 1 4 2
1:(1) 0
2:(0)
0:(0)
4:(0)

Sample Output

1
2

Source
Southeastern Europe 2000

中文:

给你一棵树,让你再树的节点上放上哨兵,每个哨兵可以看管该节点所连接的边,问你最少放多少哨兵可以看管整个树。

代码:

//#include<bits/stdc++.h>
#include <iostream>
#include <string>
#include <vector>
#include <cstring>
#include <limits>
#include <cmath>
#include <cstdio>
using namespace std;
const int maxn = 1505;
const int inf = 9999999;
typedef pair<int,int> edge;
int f1[maxn], f2[maxn]; // f1 放 f2 不放
int n;
vector<int> G[maxn];
bool child[maxn];void dfs(int cur, int pre) {for (int i=0;i<G[cur].size();i++) {if (cur == pre) {continue;}dfs(G[cur][i], cur);f2[cur] += f1[G[cur][i]];f1[cur] += min(f1[G[cur][i]], f2[G[cur][i]]);}
}int main()
{// ios::sync_with_stdio(false);while (~scanf("%d", &n)) {for (int i=0;i<maxn;i++) {G[i].clear();f1[i] = 1;}memset(child, false, sizeof(child));memset(f2, 0 ,sizeof(f2));for (int i = 1; i<=n; i++) {int node, chs ,ch;scanf("%d:(%d)",&node,&chs);for (int j=0;j<chs;j++) {scanf("%d", &ch);child[ch] = 1;G[node].push_back(ch);//G[ch].push_back(node);}}int root = 0;for (int i=0;i<n;i++) {if (!child[i]) {root = i;break;}}dfs(root, -1);cout << min(f1[root], f2[root]) << endl;}return 0;
}/*
12
0:(3) 1 2 3
1:(2) 4 5
2:(1) 6
3:(1) 11
4:(2) 7 8
5:(0)
6:(2) 9 10
7:(0)
8:(0)
9:(0)
10:(0)
11:(0)4
0:(1) 1
1:(2) 2 3
2:(0)
3:(0)
5
3:(3) 1 4 2
1:(1) 0
2:(0)
0:(0)
4:(0)4
0:(1) 1
1:(1) 2
2:(1) 3
3:(0)3
0:(1) 1
1:(1) 2
2:(0)4
0:(3) 1 2 3
1:(0)
2:(0)
3:(0)5
0:(2) 1 4
1:(2) 2 3
4:(0)
2:(0)
3:(0)1
0:(0)*/

解答:

!!!注意,仔细读题,计算的是每个节点看管的边,不是节点!别被数据坑了!!!

d p [ i ] [ 0 ] dp[i][0] dp[i][0]表示节点i不放置哨兵时,以i为根节点的子树所得到覆盖的最少哨兵数量, d p [ i ] [ 1 ] dp[i][1] dp[i][1]表示节点i放置哨兵时,以i为根几点的子树所得到的覆盖的最少哨兵数量。

那么
如果节点i不放置哨兵,那么其子节点必须放置哨兵,有:
$dp[i][0] += d p [ c h i l d [ i ] ] [ 1 ] dp[child[i]][1] dp[child[i]][1]
如果节点i放置哨兵,那么其子节点可以放置,也可以不放置,找最小的:
d p [ i ] [ 1 ] + = m i n ( d p [ c h i l d [ i ] ] [ 0 ] , d p [ c h i l d [ i ] ] [ 1 ] ) dp[i][1] += min(dp[child[i]][0],dp[child[i]][1]) dp[i][1]+=min(dp[child[i]][0],dp[child[i]][1])

这题里面数据有个比较迷惑,如果不仔细读题,那么会被带到坑里,这个坑就是每个节点最多有10个子节点。
再结合粗略的题意,要计算最小覆盖,很容易想成时每个节点放上哨兵,每个哨兵可以看管其相邻的节点。再加上每个节点最多只有10个节点,容易联想到状态压缩。可能会得到如下的状态转移方程:

设置 d p [ i ] [ 2 ] [ S ] dp[i][2][S] dp[i][2][S] 其中S为节点i所有叶子节点的状态压缩表示
d p [ i ] [ 0 ] [ S ] dp[i][0][S] dp[i][0][S]表示当前节点i不放置哨兵时,其子节点的放置状态为S时的最少覆盖。
此时,其子节点同样可以选择放置或者不放置,因为子节点有可能被子节点的字节点放置后所覆盖。

d p [ i ] [ 1 ] [ S ] dp[i][1][S] dp[i][1][S]表示当前节点i放置哨兵时,其子节点放置状态为S时的最少覆盖。
如果节点i放置,那么子节点同样可以选择放置和不放置,寻找其最小值。

这篇关于poj 1463 Strategic game的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/840876

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i